#include <iostream>
using namespace std;
class Vodopad {
public:
    bool polje;
    unsigned resenje;
    Vodopad() {
        resenje = 1;
    }
};
int main()
{
    unsigned h, n;
    cin >> h >> n;
    Vodopad a[n];
    for(unsigned i = 0; i < h; i++) {
        for(unsigned j = 0; j < n; j++) {
            cin >> a[j].polje;
            if(!a[j].polje) {
                if(!j)
                    a[j + 1].resenje += a[j].resenje;
                else if(j == n - 1) {
                    a[j - 1].resenje += a[j].resenje;
                }
                else {
                    a[j + 1].resenje += (a[j].resenje / 2);
                    a[j - 1].resenje += (a[j].resenje / 2);
                    if(a[j].resenje % 2) {
                        if(i)
                            a[j + 1].resenje++;
                        else
                            a[j - 1].resenje++;
                    }
                }
                a[j].resenje = 0;
            }
        }
    }
    for(unsigned j = 0; j < n; j++) {
        cout << a[j].resenje << " ";
    }
    return 0;
}